﻿Public Class Form1
    ' Draw a star on the form.
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        e.Graphics.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias

        ' Draw diamonds on the form.
        Dim rect1 As New RectangleF(4, 4, _
            Me.ClientSize.Width / 2 - 6, _
            Me.ClientSize.Height - 8)
        Dim rect2 As New RectangleF( _
            rect1.Right + 4, 4, _
            Me.ClientSize.Width / 2 - 6, _
            Me.ClientSize.Height - 8)

        DrawStar(e.Graphics, 9, rect1, Pens.Red, Brushes.Yellow)
        DrawStar(e.Graphics, Nothing, rect2, Nothing, Nothing)
    End Sub

    ' Draw a star.
    Private Sub DrawStar(ByVal gr As Graphics, ByVal num_points As Integer?, ByVal bounds As RectangleF, ByVal star_pen As Pen, ByVal star_brush As Brush)
        ' See if num_points is nothing.
        Dim number_of_points As Integer
        If (num_points.HasValue) Then
            number_of_points = num_points.Value
        Else
            number_of_points = 5
        End If

        ' Make room for the points.
        Dim points(0 To 2 * number_of_points - 1) As PointF

        Dim rx1 As Double = bounds.Width / 2
        Dim ry1 As Double = bounds.Height / 2
        Dim rx2 As Double = rx1 * 0.5
        Dim ry2 As Double = ry1 * 0.5
        Dim cx As Double = bounds.X + rx1
        Dim cy As Double = bounds.Y + ry1

        ' Start at the top.
        Dim theta As Double = -Math.PI / 2
        Dim dtheta As Double = Math.PI / number_of_points
        For i As Integer = 0 To 2 * number_of_points - 1 Step 2
            points(i) = New PointF( _
                CDbl(cx + rx1 * Math.Cos(theta)), _
                CDbl(cy + ry1 * Math.Sin(theta)))
            theta += dtheta

            points(i + 1) = New PointF( _
                CDbl(cx + rx2 * Math.Cos(theta)), _
                CDbl(cy + ry2 * Math.Sin(theta)))
            theta += dtheta
        Next i

        ' Fill the star.
        If (star_brush IsNot Nothing) Then gr.FillPolygon(star_brush, points)

        ' Draw the star.
        If (star_pen Is Nothing) Then star_pen = Pens.Black
        gr.DrawPolygon(star_pen, points)
    End Sub
End Class
